<?php
/**
 * Created by JetBrains PhpStorm.
 * User: paulopimenta
 * Date: 14/02/14
 * Time: 10:24
 * To change this template use File | Settings | File Templates.
 */

namespace Fiscal\Logic\NotaFiscal\Exceptions;

use \Geral\Util\AcumuladorDeMensagens;
class AprovacaoException extends \Fiscal\Logic\Exception {
    private $messageName;


    public function __construct($messagemName, $param = null){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;

        if($param) {
            parent::setParams($param);
        }
    }

    public function getMessageName()
    {
        return $this->messageName;
    }

    public static function existemErrosDeContabilizacao(){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_erro_contabil');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_erro_contabil');
    }

    public static function errosAoTentarCancelar(){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_operacao_cancelada');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_operacao_cancelada');
    }

    public static function notaFiscalNaoEncontrada(){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_notafiscal_nao_encontrada');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_notafiscal_nao_encontrada');
    }

    public static function contaSuperaValorOrcadoMes(){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_conta_supera_valor_orcado_mes');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_conta_supera_valor_orcado_mes');
    }

    public static function tipoOperacaoGeracaoInvalida(){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_tipoOperacao_geracao_invalida');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_tipoOperacao_geracao_invalida');
    }

    public static function centroCustoNaoCadastradoFilial($cdcentcust, $cdfilial){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_centro_custo_nao_cadastrado_filial', array($cdcentcust, $cdfilial));
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_tipoDeContaNaoParametrizado', array($cdcentcust, $cdfilial));
    }

    public static function tipoDeContaNaoParametrizado(){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_tipoDeContaNaoParametrizado');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_tipoDeContaNaoParametrizado');
    }

    public static function notaFiscSemModDocFic() {
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_notaFiscSemModDocFic');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_notaFiscSemModDocFic');
    }

    public static function notaFiscalEstornada() {
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_notaFiscalEstornada');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_notaFiscalEstornada');
    }

    public static function notaFiscalComErrosCadast() {
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_notaFiscalComErrosCadast');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_notaFiscalComErrosCadast');
    }

    public static function dataRefForaPerIntegEntrada() {
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_dataRefForaPerIntegEntrada');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_dataRefForaPerIntegEntrada');
    }

    public static function dataRefForaPerIntegSaida() {
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_dataRefForaPerIntegSaida');
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_dataRefForaPerIntegSaida');
    }

    public static function consistenciaFiscalSemImposto($dsconsistencia, $cdarvprod){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_consistenciaFiscalSemImposto', array($dsconsistencia, $cdarvprod));
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_consistenciaFiscalSemImposto', array($dsconsistencia, $cdarvprod));
    }

    public static function consistenciaFiscalComImposto($dsconsistencia, $cdarvprod, $cdimposto){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_consistenciaFiscalComImposto', array($dsconsistencia, $cdarvprod, $cdimposto));
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
        throw new self ('msg_consistenciaFiscalComImposto', array($dsconsistencia, $cdarvprod, $cdimposto));
    }

}