﻿-- Sistemas Integrados TEKNISA
-- Faturamento de Serviços
--
-- Nome: 9443_CVIVIEO_ETL_AUDITORIACSA.sql
--
-- Descrição:
-- View para retornar informações sobre as auditorias de CSA.
--
-- Criação:
-- 16/08/2010 Ederson Melquíades da Cunha

CREATE VIEW ETL_AUDITORIACSA AS 
   (SELECT NVL(SP.CDOPERAUDITCSA, 'XXXXXXXXXXXX') CDOPERAUDITOR, --  Dimensão 00447 Auditor (operador)
           NVL(PA.CDGERENTEIMPCLI, 'XXXXXXXXXXXX') CDGERENTEIMPCLI, --  Dimensão 00320 Gerente implantação (operador)       
           FU.CDOPERADOR AS CDOPERFUNC, -- Dimensão 00319 Funcionário (operador)
           SP.CDCLIENTE, -- Dimensão 00007 Cliente
           CASE WHEN (LU.NMFANTLUSO IS NULL) 
                THEN 'Não informada'
                ELSE LU.NMFANTLUSO||' ('||LU.CDLOCALUSO||')'
                 END AS NMFANTLUSO, -- Dimensão 00443 Unidade do cliente
           SP.NMINTCLIENTE, -- Dimensão 00043 Interlocutor
           LTRIM(PR.DSREFEPROPOSFAS||' '||SP.NRPROPOSFAS||'-'||SP.NRVERPROPFAS) DSPROPOSTA, -- 00317 Proposta (serviço)
           SP.CDTIPOSERV, -- Dimensão 00414 Tipo de serviço
           TO_CHAR(SP.DTSERVPREST, 'dy FMDS') DTSERVPREST, -- Dimensão 00315 Data
           TO_CHAR(SP.DTSERVPREST, 'YYYY') ANSERVPREST, -- Dimensão 00025 Ano
           ME.CDMESBI, -- Dimensão 00407 Mês
           ME.BIDATABI, -- Dimensão 00011 Bimestre
           ME.TRDATABI, -- Dimensão 00012 Trimestre
           ME.SEDATABI, -- Dimensão 00013 Semestre
           CASE WHEN (TO_CHAR(SP.DTSERVPREST, 'DD') >= '21') 
                 AND (TO_CHAR(SP.DTSERVPREST, 'DD') <= '31') 
                THEN TO_CHAR(TO_DATE('21/'||TO_CHAR(SP.DTSERVPREST, 'MM/YYYY')), 'DD/MM/YYYY')||' a '|| 
                     TO_CHAR(ADD_MONTHS(TO_DATE('20/'||TO_CHAR(SP.DTSERVPREST, 'MM/YYYY')), 1), 'DD/MM/YYYY')
                ELSE TO_CHAR(ADD_MONTHS(TO_DATE('21/'||TO_CHAR(SP.DTSERVPREST, 'MM/YYYY')), -1), 'DD/MM/YYYY')||' a '|| 
                     TO_CHAR(TO_DATE('20/'||TO_CHAR(SP.DTSERVPREST, 'MM/YYYY')), 'DD/MM/YYYY')
                 END AS DSPERIODO, -- Dimensão 00316 Período
           DECODE(SP.IDRESUAUDITCSA, 'NR', 1, 0) QTAUDITNAOREALIZADA, 
           DECODE(SP.IDRESUAUDITCSA, 'CO', 1, 0) QTAUDITCONFORME, 
           DECODE(SP.IDRESUAUDITCSA, 'NC', 1, 0) QTAUDITNAOCONFORME
      FROM PARCLIEFAS PA, OPERADOR FU, LICENCAUSO LU, ETLMESBI ME, PROPOSTAFAS PR, SERVPREST SP
     WHERE PA.CDCLIENTE (+) = SP.CDCLIENTE
       AND PA.IDTPFATUCLIE (+) = '5'
       AND FU.CDEMPRESA = SP.CDEMPRESA
       AND FU.CDFUNC = SP.CDFUNC
       AND LU.CDCLIENTE (+) = SP.CDCLIENTE
       AND LU.NRLICENCAUSO (+) = SP.NRLICENCAUSO
       AND ME.CDMESBI = TO_CHAR(SP.DTSERVPREST, 'MM')
       AND PR.NRPROPOSFAS = SP.NRPROPOSFAS
       AND PR.NRVERPROPFAS = SP.NRVERPROPFAS)
/     

-- VERSAO --
BEGIN ATUVEROBJ('OPERAUDITOR','0.00.000'); END;
/
